<template>
  <div>
    <div class="search-section">
      <el-select placeholder="Select Repository" v-model="selectedProjectId">
        <el-option
          v-for="project in projects"
          :key="project.id"
          :label="project.project_name"
          :value="project.id"
        >
        </el-option>
      </el-select>
      <el-button style="margin: 10px auto" type="primary" @click="getMrHandler">
        Get MRs
      </el-button>
    </div>
    <div class="mrTable">
      <!-- option for types of merge lists -->

      <section class="navigation">
        <el-select
          class="mrTableBtn"
          v-model="mergeListState"
          @change="switchMergeList(mergeListState)"
          name="request"
          id="request"
        >
          <el-option label="Merged" value="merged" />
          <el-option label="Opened" value="opened" />
        </el-select>
      </section>
      <br />
      <!-- <el-row type="flex" justify="center">
      <el-col :span="10">
        <el-table
          :data="selectedProject.approvers"
          v-if="showApprovers"
          border
          resizable
        >
          <el-table-column
            prop="approvers"
            label="Mandatory Approver"
            min-width="200"
          >
            <template>
              <p v-for="person in approvers" :key="person">
                {{ person }}
              </p>
            </template>
          </el-table-column>
          <el-table-column
            prop="no_of_approvers"
            label="No of Approvers Required"
            min-width="200"
          >
          </el-table-column>
        </el-table>
      </el-col>
    </el-row> -->
      <br />

      <!-- loader for tableLoading -->

      <!-- <div v-if="tableLoading && selectedProjectId"><h4>Loading ..</h4></div> -->
      <br />

      <!-- table starting  -->
      <el-row type="flex" justify="center" v-if="!tableLoading">
        <el-col>
          <el-table :data="tableData" border resizable>
            <el-table-column
              prop="MR_id"
              label="#Merge Request Id"
              min-width="250"
            >
              <template slot-scope="scope">
								{{ scope.row.MR_id }}
              </template>
            </el-table-column>
            <el-table-column
              prop="MR_url"
              label="Merge Request URL"
              min-width="250"
            >
              <template slot-scope="scope">
								<a :href="scope.row.MR_url">
									{{ scope.row.MR_url }}
								</a>
              </template>
            </el-table-column>
            <el-table-column prop="state" label="Merge State" min-width="250">
              <template slot-scope="scope">
                {{ scope.row.state }}
              </template>
            </el-table-column>
            <el-table-column prop="author" label="Author" min-width="250">
              <template slot-scope="scope">
                {{ scope.row.author }}
              </template>
            </el-table-column>
            <el-table-column prop="MR_id" label="Action" min-width="250">
              <template slot-scope="scope">
                <el-button
									:disabled="scope.row.state!=='opened' || scope.row.has_conflicts"
                  type="danger"
                  @click="mergeOpenRequest(scope.row.MR_id, scope.row.MR_url)"
                >
                  Merge
                </el-button>
								<p v-if="scope.row.has_conflicts">This MR has conflicts</p>
              </template>
            </el-table-column>
          </el-table>
        </el-col>
      </el-row>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      mrUrl: "",
      tableData: [],
			tableLoading:true,
      mergedList: [],
      openedList: [],
      mergeListState: "opened",
      selectedProject: undefined,
      showApprovers: false,
      selectedProjectId: "",
      projects: [
        {
          project_name: "test-project-2",
          id: 36539871,
          approvers: [
            "aayushpatniya1999@gmail.com",
            "kushmitha.1506@gmail.com",
          ],
        },
        {
          project_name: "Test project 1",
          id: 36468959,
          approvers: ["aayushpatniya1999@gmail.com", "kvsskteja@gmail.com"],
        },
        {
          project_name: "test123",
          id: 36538753,
          approvers: ["aayushpatniya1999@gmail.com","kushmitha.1506@gmail.com"],
        },
      ],
    };
  },
  methods: {
    mergeOpenRequest(id, url) {
			console.log(id,url)
			const condition = this.selectedProject.approvers.includes(this.$store.state.email)
			console.log(condition, typeof condition)
			if(condition){
				const config = {
					method: "get",
					url: `http://localhost:8080/${this.selectedProjectId}/${id}/merge`,
					// data: { requrl: url },
				};
				this.$axios(config)
					.then((res) => {
						console.log(res);
						if (res.status === 200) {
							this.$notify({
								title: "Success",
								message: "This is a success message",
								type: "success",
							});
							this.openedList.length=0;
							this.mergedList.length=0;
							this.getMrHandler();
						}
						else{
							this.$notify.error({
								title: 'Error',
								message: 'Cannot be merged'
							});
						}
					})
					.catch((e) => {
						console.log(e);

							this.$notify.error({
							title: 'Error',
							message: e
						});
					});
			}
      else{
				this.$notify.error({
					title: 'Error',
					message: "You don't have access to merge"
				});
				return
			}
    },
    switchMergeList(stateValue) {
      if (stateValue === "opened") {
        this.tableData = this.openedList;
      } else if (stateValue === "merged") {
        this.tableData = this.mergedList;
      }
    },
    getMrHandler() {
      this.showApprovers = true;
      this.selectedProject = this.projects.filter(
        (x) => x.id === this.selectedProjectId
      )[0];
      console.log(this.selectedProject);
      this.tableLoading = true;
      const config = {
        method: "get",
        url: `http://localhost:8080/${this.selectedProjectId}/merge_requests`,
      };

      this.$axios(config)
        .then((res) => {
          this.tableLoading = false;
					this.mergedList=[];
					this.openedList=[];
          this.tableData = res.data;
          this.tableData.forEach((element) => {
            if (element.state === "opened") {
              this.openedList.push(element);
            }
            if (element.state === "merged") {
              this.mergedList.push(element);
            }
          });
          this.tableData = this.openedList;
          console.log(this.openedList, this.mergedList);
        })
        .catch((err) => {
          console.log(err);
        });
    },
  },
};
</script>

<style scoped>
.search-section {
  width: 50%;
  margin: 20px auto;
}
.mrTable {
  display: flex;
  flex-direction: column;
}
.navigation {
  text-align: center;
  display: flex;
  justify-content: center;
  align-items: center;
}
.navigation {
  width: 30em;
  margin: auto;
  display: flex;
  justify-content: center;
  align-items: center;
}
.navigation label {
  width: 50%;
}

p {
  margin: 0px;
  padding: 0px;
}
h4 {
  text-align: center;
  color: blue;
}
</style>
